# Generated by Django 3.2.20 on 2023-12-07 16:58
import os
import json
from django.db import migrations, models
import django.db.models.deletion
from django.conf import settings

def add_default_recommendations(apps, schema_editor):
    ReviewRecommendation = apps.get_model("repository", "ReviewRecommendation")
    Repository = apps.get_model("repository", "Repository")

    defaults_file = open(
        os.path.join(
            settings.BASE_DIR,
            'utils',
            'install',
            'default_repository_review_recommendations.json',
        )
    )
    defaults = json.load(defaults_file)
    for repo in Repository.objects.all():
        for default in defaults:
            ReviewRecommendation.objects.get_or_create(
                repository=repo,
                name=default,
            )
    defaults_file.close()


class Migration(migrations.Migration):

    dependencies = [
        ('repository', '0040_auto_20231207_1002'),
    ]

    operations = [
        migrations.CreateModel(
            name='ReviewRecommendation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=255)),
                ('repository', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='repository.repository')),
                ('active', models.BooleanField(default=True)),
            ],
        ),
        migrations.AddField(
            model_name='review',
            name='recommendation',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to='repository.reviewrecommendation'),
        ),
        migrations.RunPython(add_default_recommendations, reverse_code=migrations.RunPython.noop)
    ]
